diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/lock.c tin-2.6.5/src/lock.c
--- tin-2.6.4/src/lock.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/lock.c	2025-11-15 17:04:47.134546975 +0100
@@ -6,7 +6,7 @@
  *  Updated   : 2024-02-27
  *  Notes     :
  *
- * Copyright (c) 1998-2025 Urs Janssen <urs@tin.org>
+ * Copyright (c) 1998-2026 Urs Janssen <urs@tin.org>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,7 +41,7 @@
 #	include "tin.h"
 #endif /* !TIN_H */
 
-#if !defined(USE_FLOCK) && !defined(USE_LOCKF) && !defined(USE_FCNTL)
+#if !defined(NO_LOCKING) && !defined(USE_FLOCK) && !defined(USE_LOCKF) && !defined(USE_FCNTL)
 #	ifdef HAVE_FCNTL
 #		define USE_FCNTL 1
 #	else
@@ -53,7 +53,7 @@
 #			endif /* HAVE_FLOCK */
 #		endif /* HAVE_LOCKF */
 #	endif /* HAVE_FCNTL */
-#endif /* !USE_FLOCK && !USE_LOCKF && !USE_FCNTL */
+#endif /* !NO_LOCKING && !USE_FLOCK && !USE_LOCKF && !USE_FCNTL */
 
 /*
  * TODO: add support for $LOCKEXT
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/mail.c tin-2.6.5/src/mail.c
--- tin-2.6.4/src/mail.c	2024-12-21 03:54:10.000000000 +0100
+++ tin-2.6.5/src/mail.c	2025-11-16 13:38:20.758380626 +0100
@@ -3,10 +3,10 @@
  *  Module    : mail.c
  *  Author    : I. Lea
  *  Created   : 1992-10-02
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-11-16
  *  Notes     : Mail handling routines for creating pseudo newsgroups
  *
- * Copyright (c) 1992-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1992-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -120,7 +120,7 @@ read_mail_active_file(
 	}
 
 	while ((buf = tin_fgets(fp, FALSE))) {
-		if (!parse_active_line(buf, &max, &min, my_spooldir) || *buf == '\0')
+		if (*buf == '\0' || *buf == '#' || !parse_active_line(buf, &max, &min, my_spooldir))
 			continue;
 
 		/*
@@ -284,36 +284,25 @@ open_newsgroups_fp(
 					unlink(local_newsgroups_file);
 			}
 		}
-		/*
-		 * TODO: test me, find a useful limit,
-		 *       optimize more than n groups (e.g. 5) of the same
-		 *       subhierarchy to a wildmat?
-		 */
-		if (((nntp_caps.type == CAPABILITIES && nntp_caps.list_newsgroups) || nntp_caps.type != CAPABILITIES) && newsrc_active && !list_active && !no_more_wildmat && (PIPELINE_LIMIT > MAX(1, num_active))) {
+		if (nntp_caps.list_newsgroups && newsrc_active && !list_active && !no_more_wildmat && (serverrc.nntp_pipeline_limit > MAX(1, num_active))) {
 			char *ptr;
 			char buff[NNTP_STRLEN];
 			char line[NNTP_STRLEN];
 			char file[PATH_LEN];
-			char serverdir[PATH_LEN];
-			int resp, i, j = 0;
+			int n, resp, i, j = 0;
 			struct t_group *group;
 
-			if (nntp_tcp_port != IPPORT_NNTP)
-				snprintf(file, sizeof(file), "%s:%u", nntp_server, nntp_tcp_port);
-			else
-				STRCPY(file, quote_space_to_dash(nntp_server));
-
-			joinpath(serverdir, sizeof(serverdir), rcdir, file);
 			joinpath(file, sizeof(file), serverdir, NEWSGROUPS_FILE".tmp");
 			*buff = '\0';
 			if ((result = fopen(file, "w")) != NULL) {
 				for_each_group(i) {
 					if ((group = group_find(active[i].name, FALSE)) != NULL) {
 						if (group->type == GROUP_TYPE_NEWS) {
-							if (nntp_caps.type == CAPABILITIES && nntp_caps.list_newsgroups) {
+							if (nntp_caps.type == CAPABILITIES) {
 								if (*buff) {
-									if (strlen(buff) + strlen(active[i].name) + 1 < NNTP_GRPLEN) {
-										snprintf(buff + strlen(buff), sizeof(buff) - strlen(buff), ",%s", active[i].name);
+									n = strlen(buff);
+									if (n + strlen(active[i].name) + 1 < NNTP_GRPLEN) {
+										snprintf(buff + n, sizeof(buff) - n, ",%s", active[i].name);
 										continue;
 									} else {
 										put_server(buff, FALSE);
@@ -327,29 +316,29 @@ open_newsgroups_fp(
 								}
 							} else
 								snprintf(buff, sizeof(buff), "LIST NEWSGROUPS %s", active[i].name);
-#		ifdef DISABLE_PIPELINING
-							if ((resp = new_nntp_command(buff, OK_GROUPS, line, sizeof(line))) != OK_GROUPS) {
-								no_more_wildmat = resp;
-								*buff = '\0';
-								break;
-							}
-							while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+							if (serverrc.nntp_pipeline_limit < 2) { /* DISABLE_PIPELINING */
+								if ((resp = new_nntp_command(buff, OK_GROUPS, line, sizeof(line))) != OK_GROUPS) {
+									no_more_wildmat = resp;
+									*buff = '\0';
+									break;
+								}
+								while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
 #			if defined(DEBUG) && defined(NNTP_ABLE)
-								if ((debug & DEBUG_NNTP) && verbose)
-									debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
+									if ((debug & DEBUG_NNTP) && verbose)
+										debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
 #			endif /* DEBUG && NNTP_ABLE */
-								fprintf(result, "%s\n", str_trim(ptr));
-							}
+									fprintf(result, "%s\n", str_trim(ptr));
+								}
 #			if defined(DEBUG) && defined(NNTP_ABLE)
-							if ((debug & DEBUG_NNTP) && !verbose)
-								debug_print_file("NNTP", "<<<%s%s", logtime(), txt_log_data_hidden);
+								if ((debug & DEBUG_NNTP) && !verbose)
+									debug_print_file("NNTP", "<<<%s%s", logtime(), txt_log_data_hidden);
 #			endif /* DEBUG && NNTP_ABLE */
 
-#		else
-							put_server(buff, FALSE);
-							*buff = '\0';
-							++j;
-#		endif /* DISABLE_PIPELINING */
+							} else {
+								put_server(buff, FALSE);
+								*buff = '\0';
+								++j;
+							}
 						}
 					}
 				}
@@ -357,33 +346,33 @@ open_newsgroups_fp(
 					put_server(buff, FALSE);
 					++j;
 				}
-#		ifndef DISABLE_PIPELINING
-				while (j--) {
-					if ((resp = get_only_respcode(line, sizeof(line))) != OK_GROUPS) {
-						if (!no_more_wildmat)
-							no_more_wildmat = resp;
-						continue;
-					}
-					while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+				if (serverrc.nntp_pipeline_limit >= 2) { /* !DISABLE_PIPELINING */
+					while (j--) {
+						if ((resp = get_only_respcode(line, sizeof(line))) != OK_GROUPS) {
+							if (!no_more_wildmat)
+								no_more_wildmat = resp;
+							continue;
+						}
+						while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
 #			if defined(DEBUG) && defined(NNTP_ABLE)
-						if ((debug & DEBUG_NNTP) && verbose)
-							debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
+							if ((debug & DEBUG_NNTP) && verbose)
+								debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
 #			endif /* DEBUG && NNTP_ABLE */
-						fprintf(result, "%s\n", str_trim(ptr));
-					}
+							fprintf(result, "%s\n", str_trim(ptr));
+						}
 #			if defined(DEBUG) && defined(NNTP_ABLE)
-					if ((debug & DEBUG_NNTP) && !verbose)
-						debug_print_file("NNTP", "<<<%s%s", logtime(), txt_log_data_hidden);
+						if ((debug & DEBUG_NNTP) && !verbose)
+							debug_print_file("NNTP", "<<<%s%s", logtime(), txt_log_data_hidden);
 #			endif /* DEBUG && NNTP_ABLE */
-				}
-				/* TODO: add 483 (RFC 3977) support */
-				if (no_more_wildmat == ERR_NOAUTH || no_more_wildmat == NEED_AUTHINFO) {
-					if (!authenticate(nntp_server, userid, FALSE)) {
-						fclose(result);
-						tin_done(EXIT_FAILURE, _(txt_auth_failed), nntp_caps.type == CAPABILITIES ? ERR_AUTHFAIL : ERR_ACCESS); /* TODO: should we exit with NNTP_ERROR_EXIT? */
+					}
+					/* TODO: add 483 (RFC 3977) support */
+					if (no_more_wildmat == ERR_NOAUTH || no_more_wildmat == NEED_AUTHINFO) {
+						if (!authenticate(nntp_server, userid, FALSE)) {
+							fclose(result);
+							tin_done(EXIT_FAILURE, _(txt_auth_failed), nntp_caps.type == CAPABILITIES ? ERR_AUTHFAIL : ERR_ACCESS); /* TODO: should we exit with NNTP_ERROR_EXIT? */
+						}
 					}
 				}
-#		endif /* !DISABLE_PIPELINING */
 				fclose(result);
 				result = fopen(file, "r");
 				unlink(file); /* unlink on close */
@@ -526,40 +515,25 @@ read_groups_descriptions(
 
 		if (group != NULL && group->description == NULL) {
 			char *r;
-			size_t r_len;
 			t_bool conv_needed = FALSE;
 
 			q = p;
 			while (*q) {
-				if (*q == '\t') /* what about '\r', '\f', '\v', '\b', '\a'? */
+				if (*q == '\t')
 					*q = ' ';
 				else {
-					if (!conv_needed && (*q < 0x20 || (unsigned char) *q > 0x7f))
+					if (!conv_needed && (*q < 0x20 || !isascii((unsigned char) *q)))
 						conv_needed = TRUE;
 				}
 				++q;
 			}
 
 			r = my_strdup(p);
-			r_len = strlen(r);
-
 			/*
 			 * Protect against invalid character sequences.
 			 */
-			if (conv_needed) {
-#ifdef CHARSET_CONVERSION
-#	ifdef USE_ICU_UCSDET
-				char *guessed_charset = guess_charset(r, 10);
-
-				process_charsets(&r, &r_len, guessed_charset ? guessed_charset : "UTF-8", tinrc.mm_local_charset, FALSE);
-				FreeAndNull(guessed_charset);
-#	else
-				process_charsets(&r, &r_len, "UTF-8", tinrc.mm_local_charset, FALSE);
-#	endif /* USE_ICU_UCSDET */
-#else
-				process_charsets(&r, &r_len, "UTF-8", tinrc.mm_local_charset, FALSE);
-#endif /* CHARSET_CONVERSION */
-			}
+			if (conv_needed)
+				csguess_convert_str(&r, "UTF-8");
 			group->description = convert_to_printable(r, FALSE);
 		}
 
@@ -590,7 +564,7 @@ print_active_head(
 }
 
 
-void
+t_bool
 find_art_max_min(
 	const char *group_path,
 	t_artnum *art_max,
@@ -615,9 +589,11 @@ find_art_max_min(
 			}
 		}
 		CLOSEDIR(dir);
+		if (*art_min == T_ARTNUM_CONST(0))
+			*art_min = T_ARTNUM_CONST(1);
+		return TRUE;
 	}
-	if (*art_min == T_ARTNUM_CONST(0))
-		*art_min = T_ARTNUM_CONST(1);
+	return FALSE;
 }
 
 
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/main.c tin-2.6.5/src/main.c
--- tin-2.6.4/src/main.c	2024-12-11 18:16:53.000000000 +0100
+++ tin-2.6.5/src/main.c	2025-12-06 18:39:58.593101891 +0100
@@ -3,10 +3,10 @@
  *  Module    : main.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-11
+ *  Updated   : 2025-12-06
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -52,7 +52,11 @@
 #		include "tnntp.h"
 #	endif /* !TNNTP_H */
 #endif /* INET6 && HAVE_INET_PTON */
+#ifndef STPWATCH_H
+#	include "stpwatch.h"
+#endif /* !STPWATCH_H */
 
+char serverdir[PATH_LEN];
 
 signed long int read_newsrc_lines = -1;
 
@@ -80,7 +84,7 @@ static void usage(char *theProgname);
 
 #define FREE_ARGV_IF_NEEDED(orig, new) do { \
 		if (orig != new) { \
-			free(*(new + 1)); \
+			FreeAndNull(*(new + 1)); \
 			FreeAndNull(new); \
 		} \
 	} while (0)
@@ -97,6 +101,7 @@ main(
 	char **argv_orig = argv;
 	int count, start_groupnum;
 	int num_cmd_line_groups = 0;
+	unsigned int srvrc_mask = 0;
 	t_bool tmp_no_write;
 
 	cmd_line = TRUE;
@@ -120,9 +125,9 @@ main(
 	 */
 #ifndef NO_LOCALE
 	{
-		const char *p;
+		const char *p = tin_nl_langinfo(CODESET);
 
-		if ((p = tin_nl_langinfo(CODESET)) != NULL) {
+		if (*p != '\0') {
 			/*
 			 * TODO: also "exclude" the other US-ASCII aliases
 			 *       csASCII, cp367, IBM367, ISO646-US, ...
@@ -207,7 +212,7 @@ main(
 	 * Read user local & global config files
 	 * These override the compiled in defaults
 	 *
-	 * must be called before setup_screen()
+	 * must be called before setup_screen(), see comment below
 	 */
 	if (!read_config_file(global_config_file, TRUE))
 		global_config_file[0] = '\0';
@@ -238,9 +243,7 @@ main(
 			tin_done(EXIT_SUCCESS, NULL);
 		}
 
-		/*
-		 * Init curses emulation
-		 */
+		/* Init curses emulation */
 		if (!InitScreen()) {
 			error_message(2, _(txt_screen_init_failed), tin_progname);
 			FREE_ARGV_IF_NEEDED(argv_orig, cmdargs);
@@ -250,9 +253,7 @@ main(
 
 		EndInverse();
 
-		/*
-		 * This depends on various things in tinrc
-		 */
+		/* depends on various things in tinrc, e.g. color settings */
 		setup_screen();
 	}
 
@@ -271,12 +272,25 @@ main(
 	if (!nntp_server || !*nntp_server)
 		nntp_server = getserverbyfile(NNTP_SERVER_FILE);
 
-	open_msglog(); /* depends on nntp_server */
-	read_server_config();
+	STRCPY(serverrc_file, quote_space_to_dash(nntp_server));
+	joinpath(serverdir, sizeof(serverdir), rcdir, serverrc_file);
+	joinpath(serverrc_file, sizeof(serverrc_file), serverdir, SERVERCONFIG_FILE);
+
+	open_msglog(); /* depends on serverdir */
+
+	/* remove help text cache if any */
+	if (!batch_mode)
+		cleanup_tmp_files();
+
+	if (update_index)
+		srvrc_mask |= SRVRC_MASK_UPDATE_INDEX;
+	if (read_saved_news)
+		srvrc_mask |= SRVRC_MASK_READ_SAVED_NEWS;
+	read_server_config(srvrc_mask);
 
 	if (read_news_via_nntp && !read_saved_news) {
 #	ifdef NNTPS_ABLE
-		if (use_nntps && !insecure_nntps) { /* RFC 8143 "3.3 Server Name Indication" */
+		if (use_nntps && !insecure_nntps) { /* RFC 8143 3.3 Server Name Indication */
 			unsigned is_ip;
 
 			if (strchr(nntp_server, ':')) /* IPv6 */
@@ -321,8 +335,8 @@ main(
 	 * why evaluate tinrc.cache_overview_files in error_message, we know
 	 * it is false -> txt_batch_update_unavail could hold a fixed string.
 	 */
-	if (update_index && !tinrc.cache_overview_files) {
-		error_message(2, _(txt_batch_update_unavail), tin_progname, print_boolean(tinrc.cache_overview_files));
+	if (update_index && !serverrc.cache_overview_files) {
+		error_message(2, _(txt_batch_update_unavail), tin_progname, print_boolean(serverrc.cache_overview_files));
 		FREE_ARGV_IF_NEEDED(argv_orig, cmdargs);
 		free_all_arrays();
 		giveup();
@@ -352,18 +366,16 @@ main(
 		read_input_history_file();
 	}
 
-	if (!(batch_mode || post_postponed_and_exit)) {
+	if (read_saved_news && !(batch_mode || post_postponed_and_exit)) {
 		/*
 		 * Load the mail & news active files into active[]
 		 *
 		 * create_save_active_file cannot write to active.save
 		 * if no_write != FALSE, so restore original value temporarily
 		 */
-		if (read_saved_news) {
-			no_write = tmp_no_write;
-			create_save_active_file();
-			no_write = TRUE;
-		}
+		no_write = tmp_no_write;
+		create_save_active_file();
+		no_write = TRUE;
 	}
 
 #ifdef HAVE_MH_MAIL_HANDLING
@@ -386,7 +398,7 @@ main(
 
 		read_attributes_file(FALSE);
 	}
-	start_groupnum = read_news_active_file(check_any_unread);
+	start_groupnum = read_news_active_file();
 #ifdef DEBUG
 	if (debug & DEBUG_MISC)
 		debug_print_active();
@@ -413,6 +425,16 @@ main(
 		num_cmd_line_groups = read_cmd_line_groups();
 
 	/*
+	 * finally we have a list of all groups and can set the attributes
+	 * if required
+	 */
+	if (!check_any_unread) {
+		BegStopWatch();
+		assign_attributes_to_groups();
+		EndStopWatch("assign_attributes_to_groups()");
+	}
+
+	/*
 	 * Quick post an article and exit if -w or -o specified
 	 */
 	if (post_article_and_exit || post_postponed_and_exit) {
@@ -423,9 +445,9 @@ main(
 		tin_done(EXIT_SUCCESS, NULL);
 	}
 
-	/* TODO: replace hard coded key-name in txt_info_postponed */
+	/* TODO: replace hard coded key-name in txt_info_postponed_sp[]* */
 	if ((count = count_postponed_articles()))
-		wait_message(3, _(txt_info_postponed), count, PLURAL(count, txt_article));
+		wait_message(3, P_(txt_info_postponed_sp[0], txt_info_postponed_sp[1], count), count);
 
 	/*
 	 * Read text descriptions for mail and/or news groups
@@ -529,6 +551,8 @@ main(
 	/*
 	 * Work loop
 	 */
+	if (cmdline.msgid && num_cmd_line_groups) /* with -L don't go to the 1st. cmd-line group */
+		(num_cmd_line_groups = 0);
 	selection_page(start_groupnum, num_cmd_line_groups);
 	/* NOTREACHED */
 	return 0;
@@ -537,7 +561,7 @@ main(
 
 /*
  * process command line options
- * [01235789beEFijJKOyY] are unused
+ * [01235789beEijJKOyY] are unused
  * [W] is reserved
  * [BPU] have been in use at some time, but now are unused:
  *   B BBS mode (M_AMIGA only)
@@ -547,7 +571,7 @@ main(
  *   C was count articles, now is activate COMPRESS DEFLATE
  *   p was set printer-cmd., now is nntp-port
  *
- * unused: [bBeEijJKOPU01235789]
+ * unused: [01235789bBeEijJKOPUyY]
  */
 #define DO_FREE() do { \
 		FreeIfNeeded(trcv); \
@@ -564,7 +588,7 @@ main(
 #define USELESS_COMB(keep,ignore) do { \
 		wait_message(2, _(txt_useless_combination), keep, ignore, ignore, BlankIfNull(trcv)); \
 	} while (0)
-#define OPTIONS "46aAcCdD:f:F:g:G:hHI:klL:m:M:nNop:qQrRs:St:TuvVwxXzZ"
+#define OPTIONS ":46aAcCdD:f:F:g:G:hHI:klL:m:M:nNop:qQrRs:St:TuvVwxXzZ"
 static char **
 read_cmd_line_options(
 	int argc,
@@ -572,7 +596,7 @@ read_cmd_line_options(
 {
 	const char *envtinrc = get_val("TINRC", NULL);
 	char **argv_orig = argv;
-	char *trcv;
+	char *trcv = NULL;
 	int n, ch;
 #if defined(NNTP_ABLE) || defined(DEBUG)
 	int i;
@@ -592,11 +616,10 @@ read_cmd_line_options(
 			if (snprintf(trcv, len, txt_option_check_tinrc, envtinrc) != n) {
 				FreeAndNull(trcv);
 			}
-		} else
-			trcv = NULL;
-	} else
-		trcv = NULL;
+		}
+	}
 
+	optopt = 0; /* AFAIK at least MINIX < 3.2.0 doesn't set optopt */
 	while ((ch = getopt(argc, argv, OPTIONS)) != -1) {
 		switch (ch) {
 			case '4':
@@ -609,7 +632,7 @@ read_cmd_line_options(
 				OPTION_EXIT("-DNNTP_ABLE");
 				/* keep lint quiet: */
 				/* NOTREACHED */
-#endif /* NNTP_ABLE && INET6 */
+#endif /* NNTP_ABLE */
 				break;
 
 			case '6':
@@ -769,33 +792,9 @@ read_cmd_line_options(
 				my_strncpy(filter_file, optarg, sizeof(filter_file) - 1);
 				break;
 
-			case 'G':
-				cmdline.getart_limit = s2i(optarg, INT_MIN, INT_MAX);
-				switch (errno) {
-					case EINVAL: /* arg not numeric */
-						error_message(0, _(txt_arg_not_numeric), "-G", optarg);
-						DO_FREE();
-						giveup();
-						/* keep lint quiet: */
-						/* FALLTHROUGH */
-						break;
-
-					case ERANGE:
-						error_message(0, _(txt_val_out_of_range_ignored), "-G", optarg, INT_MIN, INT_MAX);
-						cmdline.getart_limit = 0;
-						if (!batch_mode)
-							sleep(2);
-						break;
-
-					default:
-						break;
-				}
-				if (cmdline.getart_limit != 0)
-					cmdline.args |= CMDLINE_GETART_LIMIT;
-				break;
-
 			case 'g':	/* select alternative NNTP-server, implies -r */
 #ifdef NNTP_ABLE
+				FreeIfNeeded(cmdline.nntpserver);
 				cmdline.nntpserver = my_strdup(optarg);
 				str_trim(cmdline.nntpserver);
 				{
@@ -910,6 +909,31 @@ read_cmd_line_options(
 #endif /* NNTP_ABLE */
 				break;
 
+			case 'G':
+				cmdline.getart_limit = s2i(optarg, INT_MIN, INT_MAX);
+				switch (errno) {
+					case EINVAL: /* arg not numeric */
+						error_message(0, _(txt_arg_not_numeric), "-G", optarg);
+						DO_FREE();
+						giveup();
+						/* keep lint quiet: */
+						/* FALLTHROUGH */
+						break;
+
+					case ERANGE:
+						error_message(0, _(txt_val_out_of_range_ignored), "-G", optarg, INT_MIN, INT_MAX);
+						cmdline.getart_limit = 0;
+						if (!batch_mode)
+							sleep(2);
+						break;
+
+					default:
+						break;
+				}
+				if (cmdline.getart_limit != 0)
+					cmdline.args |= CMDLINE_GETART_LIMIT;
+				break;
+
 			case 'H':
 				show_intro_page();
 				DO_FREE();
@@ -939,6 +963,7 @@ read_cmd_line_options(
 
 			case 'L':
 #ifdef NNTP_ABLE
+				FreeIfNeeded(cmdline.msgid);
 				cmdline.msgid = my_strdup(optarg);
 				str_trim(cmdline.msgid);
 #else
@@ -949,6 +974,7 @@ read_cmd_line_options(
 				break;
 
 			case 'm':
+				FreeIfNeeded(cmdline.maildir);
 				cmdline.maildir = my_strdup(optarg);
 				break;
 
@@ -1044,6 +1070,7 @@ read_cmd_line_options(
 				break;
 
 			case 's':
+				FreeIfNeeded(cmdline.savedir);
 				cmdline.savedir = my_strdup(optarg);
 				break;
 
@@ -1059,6 +1086,7 @@ read_cmd_line_options(
 					case EINVAL: /* TODO: extra error message */
 					case ERANGE:
 						error_message(0, _(txt_val_out_of_range_reset), "-t", (int) strtol(optarg, NULL, 10), TIN_NNTP_TIMEOUT_MAX);
+						cmdline.nntp_timeout = 0;
 						if (!batch_mode)
 							sleep(2);
 						break;
@@ -1135,12 +1163,28 @@ read_cmd_line_options(
 				batch_mode = TRUE;
 				break;
 
-			case 'h':
+			case ':':
 			case '?':
+			case 'h':
 			default:
+				switch (ch) {
+					case ':':
+						my_fprintf(stderr, _(txt_error_option_missing_argument), argv[0], optopt);
+						break;
+
+					case '?':
+						my_fprintf(stderr, _(txt_error_option_unknown), argv[0], optopt);
+						break;
+
+					default:
+						break;
+				}
 				usage(tin_progname);
 				DO_FREE();
 				exit(EXIT_SUCCESS);
+				/* keep lint quiet: */
+				/* NOTREACHED */
+				break;
 		}
 	}
 
@@ -1164,28 +1208,21 @@ read_cmd_line_options(
 		if (read_news_via_nntp) {
 			nntp_server = getserverbyfile(NNTP_SERVER_FILE);
 			get_newsrcname(newsrc, sizeof(newsrc), nntp_server);
-		} else {
-			const char *nodenamebuf = get_host_name();
-
-			get_newsrcname(newsrc, sizeof(newsrc), nodenamebuf);
-		}
+		} else
+			get_newsrcname(newsrc, sizeof(newsrc), BlankIfNull(get_host_name()));
 	}
 #endif /* NNTP_ABLE */
 
 	/*
 	 * Sort out option conflicts
 	 */
-	if (!batch_mode) {
-		if (catchup) {
-			wait_message(2, _(txt_useful_with_batch_mode), "-c", BlankIfNull(trcv));
-			catchup = FALSE;
-		}
+	if (catchup && !batch_mode) {
+		wait_message(2, _(txt_useful_with_batch_mode), "-c", BlankIfNull(trcv));
+		catchup = FALSE;
 	}
-	if (!(batch_mode || debug)) {
-		if (verbose) {
-			wait_message(2, _(txt_useful_with_batch_or_debug_mode), "-v", BlankIfNull(trcv));
-			verbose = FALSE;
-		}
+	if (verbose && !batch_mode && !debug) {
+		wait_message(2, _(txt_useful_with_batch_or_debug_mode), "-v", BlankIfNull(trcv));
+		verbose = FALSE;
 	}
 	/*
 	 * NOTE: order IS important (in case where multiple conflicting settings
@@ -1343,6 +1380,7 @@ read_cmd_line_options(
 		/* USELESS_COMB("-R", "-n"); */ /* we ignore this silently */
 		newsrc_active = FALSE;
 	}
+	/* USELESS_COMB("-R", "-p"); */ /* we ignore this silently */
 	if (read_saved_news && read_news_via_nntp) {
 		/* USELESS_COMB("-R", "-r"); */ /* we ignore this silently, also catches 'p' */
 		read_news_via_nntp = FALSE;
@@ -1359,7 +1397,7 @@ read_cmd_line_options(
 		/* USELESS_COMB("-R", "-t"); */ /* we ignore this silently */
 		read_news_via_nntp = FALSE;
 		cmdline.nntp_timeout = 0;
-		cmdline.args |= CMDLINE_NNTP_TIMEOUT;
+		cmdline.args &= ~CMDLINE_NNTP_TIMEOUT;
 	}
 	if (read_saved_news && check_any_unread) {
 		USELESS_COMB("-R", "-Z");
@@ -1379,10 +1417,12 @@ read_cmd_line_options(
 	 * information for all article; this overwrites '-G limit' and disables
 	 * tinrc.getart_limit temporary
 	 */
-	if (update_index && cmdline.getart_limit ) {
-		/* USELESS_COMB("-u", "-G"); */  /* we ignore this silently */
+	if (update_index && cmdline.getart_limit) {
+		if (debug || verbose) {
+			USELESS_COMB("-u", "-G");
+		}
 		cmdline.getart_limit = 0;
-		cmdline.args |= CMDLINE_GETART_LIMIT;
+		cmdline.args &= ~CMDLINE_GETART_LIMIT;
 	}
 #ifdef DEBUG
 #	ifdef NNTP_ABLE
@@ -1440,7 +1480,7 @@ read_cmd_line_options(
 #undef OPTION_EXIT
 #undef USELESS_COMB
 #undef DO_FREE
-
+#undef OPTIONS
 
 /*
  * usage
@@ -1474,7 +1514,7 @@ usage(
 #endif /* DEBUG */
 
 	error_message(0, _(txt_usage_newsrc_file), newsrc);
-	error_message(0, _(txt_usage_getart_limit));
+	error_message(0, _(txt_usage_filter_file), filter_file);
 
 #ifdef NNTP_ABLE
 #	ifdef NNTP_DEFAULT_SERVER
@@ -1484,6 +1524,7 @@ usage(
 #	endif /* NNTP_DEFAULT_SERVER */
 #endif /* NNTP_ABLE */
 
+	error_message(0, _(txt_usage_getart_limit));
 	error_message(0, _(txt_usage_help_message));
 	error_message(0, _(txt_usage_help_information), theProgname);
 	error_message(0, _(txt_usage_index_newsdir), index_newsdir);
@@ -1518,7 +1559,7 @@ usage(
 	error_message(0, _(txt_usage_quickstart));
 
 #ifdef NNTP_ABLE
-	if (!read_news_via_nntp)
+	/* if (!read_news_via_nntp) */ /* why should we suppress the usage-info? */
 		error_message(0, _(txt_usage_read_news_remotely));
 #endif /* NNTP_ABLE */
 
@@ -1612,18 +1653,70 @@ read_cmd_line_groups(
 			if (!batch_mode)
 				wait_message(0, _(txt_matching_cmd_line_groups), cmdargs[num]);
 
-			for_each_group(i) {
-				if (match_group_list(active[i].name, cmdargs[num])) {
-					if (my_group_add(active[i].name, TRUE) != -1) {
-						++matched;
-						if (post_article_and_exit) {
-							FreeIfNeeded(tinrc.default_post_newsgroups);
-							tinrc.default_post_newsgroups = my_strdup(active[i].name);
-							break;
+			if (list_active) {
+				for_each_group(i) {
+					if (match_group_list(active[i].name, cmdargs[num])) {
+						if (my_group_add(active[i].name, TRUE) != -1) {
+							++matched;
+							if (post_article_and_exit) {
+								FreeIfNeeded(tinrc.default_post_newsgroups);
+								tinrc.default_post_newsgroups = my_strdup(active[i].name);
+								break;
+							}
+							active[i].read_during_session = TRUE; /* misuse for "-[zZMN] grp" */
 						}
-						active[i].read_during_session = TRUE; /* misuse for "-[zZMN] grp" */
 					}
 				}
+			} else {
+				char *ng, *ngp, *newsgroups;
+				char *moderated = my_malloc(NNTP_STRLEN);
+				struct t_group *ptr;
+				t_artnum count = T_ARTNUM_CONST(-1), min = T_ARTNUM_CONST(1), max = T_ARTNUM_CONST(0);
+
+				ngp = newsgroups = my_strdup(cmdargs[num]);
+				while ((ng = strsep(&newsgroups, ","))) { /* strsep to avoid nested srtok via parse_active_line() */
+					if (!group_get_art_info(spooldir, ng, GROUP_TYPE_NEWS, &count, &max, &min)) {
+						if (my_group_add(ng, FALSE) < 0) {
+							if ((ptr = group_add(ng)) != NULL) {
+								++matched;
+								moderated[0] = 'y';
+								moderated[1] = '\0';
+
+								/* try to get real group flag */
+#	ifdef NNTP_ABLE
+								if (read_news_via_nntp && nntp_caps.list_active && nntp_caps.type == CAPABILITIES)
+									nntp_list_active_grp(ng, moderated);
+#	endif /* NNTP_ABLE */
+#	ifndef NNTP_ONLY
+								if (!read_news_via_nntp && !list_active) {	/* fetching flag from active-file */
+									char *rp;
+									FILE *fp;
+									t_artnum ac_min = T_ARTNUM_CONST(1), ac_max = T_ARTNUM_CONST(0);
+
+									if ((fp = tin_fopen(news_active_file, "r")) != NULL) {
+										while ((rp = tin_fgets(fp, FALSE)) != NULL) {
+											if (parse_active_line(rp, &ac_max, &ac_min, moderated)) { /* parse_active_line() modifies rp*/
+												if (!strcmp(rp, ng))
+													break;
+											}
+										}
+										fclose(fp);
+									}
+								}
+#	endif /* !NNTP_ONLY */
+								active_add(ptr, count, max, min, moderated);
+								my_group_add(ng, FALSE);
+								if (post_article_and_exit && matched == 1) { /* first group only */
+									FreeIfNeeded(tinrc.default_post_newsgroups);
+									tinrc.default_post_newsgroups = my_strdup(ng);
+								}
+							}
+						} else
+							++matched;
+					}
+				}
+				FreeAndNull(ngp);
+				free(moderated);
 			}
 		}
 	}
@@ -1670,9 +1763,10 @@ handle_cmdargs(
 
 	if (init)
 		argv_modified = TRUE;
+
 	else if (argv_modified) {
 		if (cmdargs) {
-			free(*(cmdargs + 1));
+			FreeAndNull(*(cmdargs + 1));
 			free(cmdargs);
 			cmdargs = NULL;
 		}
@@ -1690,7 +1784,7 @@ _Noreturn void
 giveup(
 	void)
 {
-	static int nested;
+	static int nested = 0;
 
 #ifdef XFACE_ABLE
 	slrnface_stop();
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/makecfg.c tin-2.6.5/src/makecfg.c
--- tin-2.6.4/src/makecfg.c	2024-12-21 03:18:16.000000000 +0100
+++ tin-2.6.5/src/makecfg.c	2025-12-05 10:39:07.143923192 +0100
@@ -3,10 +3,10 @@
  *  Module    : makecfg.c
  *  Author    : Thomas E. Dickey
  *  Created   : 1997-08-23
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-12-05
  *  Notes     : #defines and structs for options_menu.c
  *
- * Copyright (c) 1997-2025 Thomas E. Dickey <dickey@invisible-island.net>
+ * Copyright (c) 1997-2026 Thomas E. Dickey <dickey@invisible-island.net>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -105,8 +105,8 @@ extern size_t strlen(const char *);
 #define L_CURL '{'
 #define R_CURL '}'
 
-#define MAXNAME 36 /* maximum name-length (just for readability formatting) */
-#define MAXTYPE 5  /* limits opt_type to keep names unique within 31 chars */
+#define MAXNAME 36	/* maximum name-length (just for readability formatting) */
+#define MAXTYPE 5	/* limits opt_type to keep names unique within 31 chars */
 
 #define MYDATA struct mydata
 MYDATA {
@@ -116,7 +116,6 @@ MYDATA {
 };
 
 static MYDATA *all_data;
-static int line_no;
 
 static _Noreturn void
 failed(
@@ -192,7 +191,6 @@ parse_tbl(
 		s++;
 	buffer = s;
 
-	line_no++;
 	if (*buffer != ';' && *buffer != '\0') {	/* ignore comments */
 		if (*buffer == '#') {
 			store_data(buffer, "");
@@ -283,12 +281,14 @@ generate_tbl(
 		,"#define OPT_STRING    3"
 		,"#define OPT_NUM       4"
 		,"#define OPT_CHAR      5"
+		,"#define OPT_DUMMY     6"
 		,""
 		,"struct t_option option_table[]={"
 		,NULL
 	};
 	static const char *const table_2[] =
 	{
+		"  { OPT_DUMMY,   0, NULL, NULL, NULL },",
 		"};"
 		,NULL
 	};
@@ -350,6 +350,7 @@ generate_enum(
 	static const char *const table_2[] = {
 		"\tSIGNAL_HANDLER };",
 		"",
+		"#define FIRST_OPT OPT_DISPLAY_OPTIONS",
 		"#define LAST_OPT (SIGNAL_HANDLER - 1)",
 		NULL
 	};
@@ -365,9 +366,9 @@ generate_enum(
 			fprintf(ofp2, "\tOPT_");
 			while (*s != '\0') {
 				fprintf(ofp2, "%c",
-					 (*s >= 'a' && *s <= 'z')
-					 ? ((unsigned char) ((*s) - 'a' + 'A'))
-					 : *s);
+					(*s >= 'a' && *s <= 'z')
+					? ((unsigned char) ((*s) - 'a' + 'A'))
+					: *s);
 				s++;
 			}
 			fprintf(ofp2, ",\n");
@@ -387,15 +388,15 @@ generate_ptr(
 	int after;
 
 	switch (mode) {
-	case 0:
-		fprintf(ofp, "\n%s %s_list[] = %c\n", ptr_type, opt_type, L_CURL);
-		break;
-	case 1:
-		fprintf(ofp, "\ntypedef OTYP %c\n", L_CURL);
-		break;
-	case 2:
-		fprintf(ofp, "\n");
-		break;
+		case 0:
+			fprintf(ofp, "\n%s %s_list[] = %c\n", ptr_type, opt_type, L_CURL);
+			break;
+		case 1:
+			fprintf(ofp, "\ntypedef OTYP %c\n", L_CURL);
+			break;
+		case 2:
+			fprintf(ofp, "\n");
+			break;
 	}
 	after = FALSE;
 
@@ -418,41 +419,41 @@ generate_ptr(
 				after = TRUE;
 			}
 			switch (mode) {
-			case 0:
-				fprintf(ofp, "\t&tinrc.%s,%*s/* %2d: %s__ */\n",
-					p->name,
-					MAXNAME - (int) (1 + strlen(p->name)),
-					" ",
-					index_of(p),
-					p->name);
-				break;
-			case 1:
-				fprintf(ofp, "\tOVAL(oinx_%.*s, %s__)\n",
-					MAXTYPE, opt_type,
-					p->name);
-				break;
-			case 2:
-				fprintf(ofp, "#define OINX_%-*.*s OINX(oinx_%.*s, %s__)\n",
-					MAXNAME, MAXNAME,
-					p->name,
-					MAXTYPE, opt_type,
-					p->name);
-				break;
+				case 0:
+					fprintf(ofp, "\t&tinrc.%s,%*s/* %2d: %s__ */\n",
+						p->name,
+						MAXNAME - (int) (1 + strlen(p->name)),
+						" ",
+						index_of(p),
+						p->name);
+					break;
+				case 1:
+					fprintf(ofp, "\tOVAL(oinx_%.*s, %s__)\n",
+						MAXTYPE, opt_type,
+						p->name);
+					break;
+				case 2:
+					fprintf(ofp, "#define OINX_%-*.*s OINX(oinx_%.*s, %s__)\n",
+						MAXNAME, MAXNAME,
+						p->name,
+						MAXTYPE, opt_type,
+						p->name);
+					break;
 			}
 		}
 	}
 
 	switch (mode) {
-	case 0:
-		fprintf(ofp, "%c;\n", R_CURL);
-		break;
-	case 1:
-		fprintf(ofp, "\tOVAL(oinx_%.*s, s_MAX)\n", MAXTYPE, opt_type);
-		fprintf(ofp, "\tOEND(oinx_%.*s, Q1)\n", MAXTYPE, opt_type);
-		fprintf(ofp, "%c oinx_%.*s;\n", R_CURL, MAXTYPE, opt_type);
-		break;
-	case 2:
-		break;
+		case 0:
+			fprintf(ofp, "%c;\n", R_CURL);
+			break;
+		case 1:
+			fprintf(ofp, "\tOVAL(oinx_%.*s, s_MAX)\n", MAXTYPE, opt_type);
+			fprintf(ofp, "\tOEND(oinx_%.*s, Q1)\n", MAXTYPE, opt_type);
+			fprintf(ofp, "%c oinx_%.*s;\n", R_CURL, MAXTYPE, opt_type);
+			break;
+		case 2:
+			break;
 	}
 }
 
@@ -529,7 +530,6 @@ makecfg(
 	/*
 	 * Process the input file.
 	 */
-	line_no = 0;
 	while (fgets(buffer, sizeof(buffer) - 1, ifp))
 		parse_tbl(buffer);
 	fclose(ifp);
